echo off
cls
rem this is file TFUPDATE.BAT

rem	Copyright 1991 (c) Trimble Navigation Ltd., All rights reserved.
rem     645 N. Mary Ave., Sunnyvale, CA  94088
rem	Trimble 4000S Surveyor Firmware Update Utility
rem     Version of this file is  91.156  June 5 1991

rem /* set up initial conditions */
set rc=rtn0
mode serial=on >nul

rem /* query environment variable 'spnum' to decide which serial port to use */
rem /* if 'spnum' set to 2, install spdrive on com2: */
rem tset >nul
if "%spnum%" == "2" spdrive /2 >nul
if not "%spnum%" == "2" spdrive >nul

verify on 

if exist rameprom.img erase rameprom.img

echo 
echo Please set your 4000ST SERIAL PORT PARAMETERS to a FORMAT of 8-ODD--1
pause
echo 

tfupd %1 %2 %3 %4 %5 %6 %7 %8 %9 %10
if errorlevel 20 if not errorlevel 21 goto userterm
if errorlevel 13 if not errorlevel 14 goto no_permission
if errorlevel 12 if not errorlevel 13 goto fail_initial
if errorlevel 11 if not errorlevel 12 goto rameprom_img
if errorlevel 10 if not errorlevel 11 goto badend
if errorlevel 9 if not errorlevel 10 goto noforms
if errorlevel 6 if not errorlevel 7 goto badfwfile
if errorlevel 5 if not errorlevel 6 goto cantuserbaud
if errorlevel 4 if not errorlevel 5 goto rs232prob
if errorlevel 3 if not errorlevel 4 goto notlegalbaud
if errorlevel 2 if not errorlevel 3 goto several
if errorlevel 1 if not errorlevel 2 goto nospdrive
if errorlevel 0 if not errorlevel 1 goto fini

goto fini

:no_permission
echo THE ATTACHED 4000S RECEIVER IS NOT CONFIGURED FOR FIRMWARE UPDATE PERMISSION.
echo NEW FIRMWARE CAN ONLY BE INSTALLED AT THE FACTORY.
goto fini

:fail_initial
echo RS232 COMMUNICATION FAILURE IMMEDIATELY AFTER ESTABLISHING RS232 CONTACT.
echo PLEASE RETRY.
goto fini

:userterm
echo OPERATION TERMINATED WITH 'CONTROL-C' OR 'BREAK'
goto fini

:nospdrive
echo .
echo SERIAL PORT DRIVER 'SPDRIVE' HAS NOT BEEN INSTALLED.  CHECK 'PATH' 
echo STATEMENT OR PLACE A COPY OF SPDRIVE IN CURRENT DIRECTORY.
goto fini

:notlegalbaud
echo ILLEGAL BAUD RATE IN PROGRAM CALL
goto fini

:rs232prob
echo CANNOT INITIATE RS232 COMMUNICATIONS
echo  Please check baud rate and connections and try again.
echo  The RS232 parameters should be 8-odd-1.  This means 8 data bits,
echo    odd parity, and 1 stop bit.
echo  Insure that the 4000ST baud rate is not set to any of the following:
echo   150, 300, 600.   Communication can only be established if the 4000ST
echo  baud rate is set at 1200 baud or higher.
echo  Another possible reason for this diagnostic is that the 4000ST front
echo  panel is displaying "ROMS U5 AND U10 MISSING OR ERASED - PUSH CLEAR KEY"
echo  or a similar message.  If this is the case, push the CLEAR key on the
echo  receiver front panel and call TFUPDATE again.
echo  Another possible reason for this diagnostic is that the serial port
echo  driver, SPDRIVE, is installed on the wrong serial port.  If your
echo  computer is configured with the 4000ST connected to serial port 2,
echo  then reboot your computer, and before calling TFUPDATE, type
echo  SPDRIVE /2 at the DOS prompt.  Then call TFUPDATE.   This procedure
echo  should be necessary only if you do not have TNL's TRIMVEC s/w installed
echo  on your computer.
echo  The  message "REMOTE MONITOR ACTIVE" will appear on the 4000ST
echo  front panel after TFUPDATE has established a proper RS232 connection.
goto fini

:cantuserbaud
echo CANNOT ESTABLISH RS232 COMMUNICATIONS AT USER SELECTED BAUD RATE
echo Check rate and connections and try again.
echo Insure that your 4000ST SERIAL PORT PARAMETERS are set to a FORMAT of
echo 8-ODD--1.
goto fini

:badfwfile
echo SOMETHING IS WRONG WITH THE INPUT FILE(S) .FW1, .FW2, OR .FW3
echo CALL TRIMBLE NAVIGATION
goto fini

:noforms
echo CANNOT GET MENU SUBSYSTEM TO FUNCTION
goto fini

:rameprom_img
if exist rameprom.img type rameprom.img
goto fini

:several
echo ERROR CODE 2 -- 3 POSSIBLE REASONS
echo  REASON 1  INCORRECT CALL PARAMETER. (/c /b 38400, etc)
echo  REASON 2  FILE ST4000U.FIN CAN'T BE OPENED OR CANNOT BE READ PROPERLY
echo  REASON 3  USER ENTERED BAUD RATE IS NOT A LEAGAL VALUE (39400 vs 38400)
goto fini


:fini
rem trel >nul
echo on


